Device 16F876A 

'-------------------------------- -------------------------------------------------- 
Xtal 4 
Declare All_Digital = 1 
Declare PortB_Pullups = OFF '    PORTB 
Declare CCP1_Pin PORTC.2 '  HPWM  CCP1 
Declare CCP2_Pin PORTC.1 '  HPWM  CCP2 

Declare SDA_Pin PORTC.4
Declare SCL_Pin PORTC.3
'------------------------------------- ---------------------------------------------- 
TRISA = %00000011 
TRISB = %00001111 
TRISC = %00000001 
PORTB = %00000000 
PORTC = %00000000 
'----------------------------------- ----------------------------------------- 
Symbol DS PORTC.5 '     
Symbol SH_CP PORTC.7 '      
Symbol ST_CP PORTC.6 '   
Dim Value As Byte '     
Dim n As Byte '       
Dim i As Word '    
Dim j As Word '    

Symbol setup  = PORTB.1
Symbol up  = PORTB.2
Symbol down = PORTB.3
Symbol enter = PORTB.4
Symbol rtc_read = %11010001 '     
Symbol rtc_write = %11010000 '     

Dim hr As Byte '    DS1307 
Dim hr1 As Byte '     



Dim tmp As Byte 
Dim tmp1 As Byte



Dim x As Byte
Dim y As Byte
x = 127

'HPWM 1, 255 , 1000  '      
PORTC.2 = 1
in:
;HBStart
BusOut rtc_write, $07, [%00010000] 
;HBStop



'------------------------------------- --------------------------------------------- 
Start: 
For y = 0 To 9999 
For j = 0 To 30

GoSub read_time
GoSub Ind 
DelayMS 10 
Next
Next
 
GoTo Start 
'--------------------------------- -------------------------------------------- 
Ind: 
 n = Dig hr1, 0
 GoSub Convert
 SHOut DS, SH_CP, MsbFirst, [Value]
 n = Dig hr1, 1
 GoSub Convert
 SHOut DS, SH_CP, MsbFirst, [Value] 
 n = Dig hr1, 2
 GoSub Convert
 SHOut DS, SH_CP, MsbFirst, [Value] 
 n = Dig hr1, 3
 GoSub Convert
 SHOut DS, SH_CP, MsbFirst, [Value]
'n = hr1.0: GoSub Convert: SHOut DS, SH_CP, MsbFirst, [Value] 
'n = hr1.1: GoSub Convert: SHOut DS, SH_CP, MsbFirst, [Value]
'n = hr1.2: GoSub Convert: SHOut DS, SH_CP, MsbFirst, [Value]
'n = hr1.3: GoSub Convert: SHOut DS, SH_CP, MsbFirst, [Value]
PulsOut ST_CP, 10  

Return 
'----------------------------  ------------------------------------- 
Convert: 
Value = LookUpL n, [192,249,164,176,153,146,130,248,128,144,156] '      
'Value = LookUpL n, [63,6,91,79,102,109,125,7,127,111] '      

Return 



read_time: 
;HBStart
hr = BusIn rtc_read, 0x00
;HBStop 
tmp = hr 
GoSub fix_bcd_in
hr1 = tmp 
 Return

fix_bcd_in:
tmp1 = tmp & 15 
tmp = tmp >> 4 
tmp = tmp1 + 10 * tmp 
Return 





